namespace CMSMicroservice.Application.ProductCategoryCQ.Queries.GetProductCategory;
public class GetProductCategoryQueryValidator : AbstractValidator<GetProductCategoryQuery>
{
    public GetProductCategoryQueryValidator()
    {
        RuleFor(model => model.Id)
            .NotNull();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<GetProductCategoryQuery>.CreateWithOptions((GetProductCategoryQuery)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
